<!DOCTYPE html>
<html>

<head>
	<title>Dijkstra's Algorithm</title>
	<meta name="viewport" content="width=device-width,height=device-height,initial-scale=1.0" />
	<meta charset="utf-8" />
	<style>
		.exp {
			display: none;
		}
		
		table {
			font-family: arial, sans-serif;
			border-collapse: collapse;
			width: 100%;
			text-align: center;
		}
		
		th {
			background-color: #2780C6;
			text-align: center !important;
			color: #fff;
		}
		
		#headings {
			background-color: #2780C6;
			text-align: center;
			color: #fff;
		}
		
		td {
			border: 1px solid #dddddd;
			padding: 8px;
			text-align: center;
			height: 20px;
		}
		
		tr:hover {
			background-color: #ddd;
		}
	</style>

        <!-- Google Tag Manager -->
        <script class="gtm">
          window.dataLayer = window.dataLayer || [];
          
          window.dataLayer.push ({
          'labName': 'Data Structures – 2',
          'discipline': 'Computer Science and Engineering',
          'college': 'IIITH',
          'phase': '3',
          'expName': 'Dijkstras Shortest Path',
          'expShortName': 'dijkstra-algorithm'
          });

          

          (function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
          new Date().getTime(),event:'gtm.js'});var
          f=d.getElementsByTagName(s)[0],
          j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
          'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
          })(window,document,'script','dataLayer','GTM-W59SWTR');
        </script>
        <!-- End Google Tag Manager -->

</head>

<body>
  <!-- Google Tag Manager (noscript) -->
  <noscript class="gtm">
    <iframe height="0" width="0"
      src="https://www.googletagmanager.com/ns.html?id=GTM-W59SWTR"
      style="display:none;visibility:hidden">
    </iframe>
  </noscript>
  <!-- End Google Tag Manager (noscript) -->

  <div class="exp" title="Dijkstra's Algorithm Experiment">
    <div class="longt">
      <h1 class="hlongt">Introduction to Dijkstra's Algorithm</h1>
		</div>
		<div class="preamble">
			<div class="art txt" title="Estimation">
				<div class="longt">
					<h2 class="hlongt">Estimated Time</h2>
				</div>
				<div class="art-body">
					<p>1 hour</p>
				</div>
			</div>
			<div class="art txt" title="Motivation">
				<div class="longt">
					<h2 class="hlongt">Motivation</h2>
				</div>
				<div class="art-body">
					<i>Everyone wants to reach the destination as fast as possible</i> – Anonymous
				</div>
			</div>
			<div class="art req" title="Dijkstra’s Algorithm Introduction">
				<div class="longt">
					<h2 class="hlongt">Introduction</h2>
				</div>
				<div class="description">
					<p> Introduction video for Dijkstra’s Algorithm</p>
				</div>
			</div>
			<div class="art txt" title="Prerequisites">
				<div class="longt">
					<h2 class="hlongt">Prerequisites of the Experiment</h2>
				</div>
				<div class="art-body">
					<p>
						This experiment requires you to have basic knowledge about :
					</p>
					<ul>
						<li>Basic knowledge of <a href="https://en.wikipedia.org/wiki/Graph_(abstract_data_type)">graphs </a>(data structure)</li>
						<li>Familiarity with data structures such as <a href="https://en.wikipedia.org/wiki/Queue_(abstract_data_type)">queues and priority queues</a>.</li>
						<li>Calculation of basic <a href="http://10.4.12.203/bst/artefacts/build/code/static/videos/Complexity.mp4">time and space complexity</a>.</li>
						<li>Intuition about the Greedy Choice Algorithms</li>
						<li>Knowledge about Graph Traversal Algorithms</li>
						<li>And above all, a curiosity to learn and explore..!</li>
					</ul>
					Click on the above links for a short video elaborating each of the concepts.
				</div>
			</div>
			<div class="art txt" title="Overview">
				<div class="longt">
					<h2 class="hlongt">Overview of the Experiment</h2>
				</div>
				<div class="art-body">
					<ul>
						<li>The aim of this experiment is to understand the Dijkstra’s Shortest Path algorithm, its time and space complexity, and how it compares against other shortest path algorithms. </li>
						<li>The experiment features a series of modules with video lectures,interactive demonstrations, simulations, hands-on practice exercises and quizzes to self analyze.</li>
					</ul>
				</div>
			</div>
			<div class="art txt" title="Learning Objectives">
				<div class="longt">
					<h2 class="hlongt">Learning Objectives of the Experiment</h2>
				</div>
				<div class="art-body">
					<p>In this experiment on Dijkstra's Shortest Path algorithm, you will learn following:</p>
					<ul>
						<li>(Understanding) Student is able to describe 2 real-world scenarios where shortest path algorithms are required.</li>
						<li>(Remembering) Can recall the time complexity of graph traversal.</li>
						<li>(Applying) Can analyze the problem and choose suitable shortest path algorithm.</li>
						<li>(understanding) Understands the intuition of the algorithm and hence can implement the underlying data structures required.</li>
						<li>(understanding) Can visually demonstrate the steps followed by Dijkstra’s Shortest Path Algorithm.</li>
						<li>(understanding) Can recall and derive the space and time complexity of the Dijkstra’s Algorithm.</li>
						<li>(applying) Can apply Dijkstra’s Algorithm in real world problems.</li>
					</ul>
				</div>
			</div>
			<div class="art txt" title="Modules and Weightage">
				<div class="longt">
					<h2 class="hlongt">Experiment Modules and their Weightage</h2>
				</div>
				<div class="art-body">
					<table width=100%>
						<thead>
							<tr>
								<th>Module</th>
								<th>Weightage</th>
								<th>Expectation</th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td>Pre-test</td>
								<td>5%</td>
								<td>Solve All Questions</td>
							</tr>
							<tr>
								<td>Shortest Path Algorithms</td>
								<td>15%</td>
								<td>Answer the Conceptual questions</td>
							</tr>
							<tr>
								<td>The Dijkstra Algorithm</td>
								<td>30%</td>
								<td>Try all operations with atleast two examples</td>
							</tr>
							<tr>
								<td>Applications</td>
								<td>25%</td>
								<td>Applying the concept to solve a problem</td>
							</tr>
							<tr>
								<td>Post-assessment</td>
								<td>25%</td>
								<td>Solve All Questions</td>
							</tr>
						</tbody>
					</table>
				</div>
			</div>
		</div>
		<div class="lu" title="Pre-test">
			<div class="longt">
				<h1 class="hlongt">Pre-test of the Experiment</h1>
			</div>
			<div class="preamble">
				<div class="art txt" title="Estimation">
					<div class="longt">
						<h2 class="hlongt">Estimated Time</h2>
					</div>
					<div class="art-body">
						<p>20 minutes</p>
					</div>
				</div>
				<div class="art txt" title="Instructions">
					<div class="longt">
						<h2 class="hlongt">Instructions for Pre-Test</h2>
					</div>
					<div class="art-body">
						<ul>
							<li>Pretest includes questions on <strong>graphs, queues, priority queues and time and space complexity.</strong></li>
							<li>If you want to revise these topics before taking the quiz, go through the recap module first.</li>
							<li>Read the questions in the quiz section and select the correct option from the ones provided. Please note that some questions may have<strong> more than one correct response.</strong></li>
						</ul>
					</div>
				</div>
			</div>
			<div class="task" title="Recap">
				<div class="longt">
					<h2 class="hlongt">Quick look at Graphs, Queues, Greedy choice algorithms</h2>
				</div>
				<div class="art txt" title="Graphs">
					<div class="longt">
						<h2 class="hlongt">Graphs</h2>
					</div>
					<div class="art-body">
						<p>Graphs are mathematical structures that represent pairwise relationships between objects. A graph is a flow structure that represents the relationship between various objects. It can be visualized by using the following two basic
							components:
						</p>
						<ol>
							<li>
								Nodes: These are the most important components in any graph. Nodes are entities whose relationships are expressed using edges. If a graph comprises 2 nodes and an undirected edge between them, then it expresses a bi-directional relationship between the
								nodes and edge.
							</li>
							<li>
								Edges: Edges are the components that are used to represent the relationships between various nodes in a graph. An edge between two nodes expresses a one-way or two-way relationship between the nodes.
							</li>
						</ol>
					</div>
				</div>
				<div class="art req" title="Undirected Graph Illustration">
					<div class="longt">
						<h2 class="hlongt">Undirected graph</h2>
					</div>
					<div class="description">
						Picture shows undirected graphs.
					</div>
				</div>
				<div class="art req" title="Directed Graph Illustration">
					<div class="longt">
						<h2 class="hlongt">Directed graph</h2>
					</div>
					<div class="description">
						Picture shows directed graphs.
					</div>
				</div>
				<div class="art txt" title="Queues">
					<div class="longt">
						<h2 class="hlongt">Queues</h2>
					</div>
					<div class="art-body">
						<p>Queues are data structures that follow the First In First Out (FIFO) i.e. the first element that is added to the queue is the first one to be removed. Elements are always added to the back and removed from the front. Think of it
							as a line of people waiting for a bus. The person who is at the beginning of the line is the first one to enter the bus.<br>Queues support the following fundamental functions:</p>
							<ol>
								<li>
									Enqueue: If the queue is not full, this function adds an element to the back of the queue, else it prints “OverFlow”.
								</li>
								<li>
									Dequeue: If the queue is not empty, this function removes the element from the front of the queue, else it prints “UnderFlow”.
								</li>
								<li>
									Front: This function returns the front element of the queue.
								</li>
							</ol>
						</div>
					</div>
					<div class="art req" title="Queue Illustration">
						<div class="longt">
							<h2 class="hlongt">Functions related to queues</h2>
						</div>
						<div class="description">
							Picture demonstrates functions related to queues.
						</div>
					</div>
					<div class="art txt" title="Time and Space Complexity">
						<div class="longt">
							<h2 class="hlongt">Time and Space Complexity</h2>
						</div>
						<div class="art-body">
							Time complexity of an algorithm gives the measure of time taken by it to run as a function of the length of the input. Similarly, Space complexity of an algorithm quantifies the amount of space or memory taken by an algorithm to run as a function of the
							length of the input.
						</div>
					</div>
				</div>
				<div class="quiz" title="Pre-test Quiz">
					<div class="longt">
						<h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
					</div>

					<div class="mcq">
						<div class="preamble">
							<div class="art txt" title="question1">
								<div class="art-body">
									<p>Q1. Which of the following statements is/are TRUE for an undirected graph?
										<br>P: Number of odd degree vertices is even
										<br>Q: Sum of degrees of all vertices is even?</p>
									</div>
								</div>
							</div>
							<div class="choice" data-correct="false">
								<div class="preamble">
									<div class="art txt" title="q1-c1">
										<div class="art-body">
											<p>(A) P Only</p>
										</div>
									</div>
								</div>
							</div>
							<div class="choice" data-correct="false">
								<div class="preamble">
									<div class="art txt" title="q1-c2">
										<div class="art-body">
											<p>(B) Q Only</p>
										</div>
									</div>
								</div>
							</div>
							<div class="choice" data-correct="true">
								<div class="preamble">
									<div class="art txt" title="q1-c3">
										<div class="art-body">
											<p>(C) Both P and Q</p>
										</div>
									</div>
								</div>
							</div>
							<div class="choice" data-correct="false">
								<div class="preamble">
									<div class="art txt" title="q1-c4">
										<div class="art-body">
											<p>(D) Neither P nor Q</p>
										</div>
									</div>
								</div>
							</div>
							<div class="explanation">
								<div class="art txt" title="Explanation">
									<div class="art-body">
										<p>P is true for undirected graph as adding an edge always increases degree of two vertices by 1. <br> Q is true: If we consider sum of degrees and subtract all even degrees, we get an even number because every edge increases
											the sum of degrees by 2. So total number of odd degree vertices must be even.
										</p>
									</div>
								</div>
							</div>
						</div>

						<div class="mcq">
							<div class="preamble">
								<div class="art txt" title="question2">
									<div class="art-body">
										<p>Q2. Which of the following data structure is useful in traversing a given graph by breadth first search?</p>
									</div>
								</div>
							</div>
							<div class="choice" data-correct="false">
								<div class="preamble">
									<div class="art txt" title="q2-c1">
										<div class="art-body">
											<p>(A) Stack</p>
										</div>
									</div>
								</div>
							</div>
							<div class="choice" data-correct="false">
								<div class="preamble">
									<div class="art txt" title="q2-c2">
										<div class="art-body">
											<p>(B) List</p>
										</div>
									</div>
								</div>
							</div>
							<div class="choice" data-correct="true">
								<div class="preamble">
									<div class="art txt" title="q2-c3">
										<div class="art-body">
											<p>(C) Queue</p>
										</div>
									</div>
								</div>
							</div>
							<div class="choice" data-correct="false">
								<div class="preamble">
									<div class="art txt" title="q2-c4">
										<div class="art-body">
											<p>(D) None of these</p>
										</div>
									</div>
								</div>
							</div>
							<div class="explanation">
								<div class="art txt" title="Explanation">
									<div class="art-body">
										<p> BFS performs level-order traversal which can be fairly done using a queue. A queue uses FIFO ordering and the nodes that we enqueue first are explored first maintaining the order of traversal.
										</p>
									</div>
								</div>
							</div>
						</div>
						<div class="mcq">
							<div class="preamble">
								<div class="art txt" title="question3">
									<div class="art-body">
										<p>Q3. What does it mean when we say that an algorithm X is asymptotically more efficient than Y?</p>
									</div>
								</div>
							</div>
							<div class="choice" data-correct="false">
								<div class="preamble">
									<div class="art txt" title="q3-c1">
										<div class="art-body">
											<p>(A) X will always be a better choice for small inputs</p>
										</div>
									</div>
								</div>
							</div>
							<div class="choice" data-correct="true">
								<div class="preamble">
									<div class="art txt" title="q3-c2">
										<div class="art-body">
											<p>(B) X will always be a better choice for large inputs</p>
										</div>
									</div>
								</div>
							</div>
							<div class="choice" data-correct="false">
								<div class="preamble">
									<div class="art txt" title="q3-c3">
										<div class="art-body">
											<p>(C) Y will always be a better choice for small inputs</p>
										</div>
									</div>
								</div>
							</div>
							<div class="choice" data-correct="false">
								<div class="preamble">
									<div class="art txt" title="q3-c4">
										<div class="art-body">
											<p>(D) X will always be a better choice for all inputs</p>
										</div>
									</div>
								</div>
							</div>
							<div class="explanation">
								<div class="art txt" title="Explanation">
									<div class="art-body">
										<p>Performance could be similar for small inputs, but definitely better for larger inputs
										</p>
									</div>
								</div>
							</div>
						</div>

						<div class="mcq">
							<div class="preamble">
								<div class="art txt" title="question4">
									<div class="art-body">
										<p>Q4. What is the time and space complexity for the given code?
											<pre><code>
int a = 0, b = 0; 
for (i = 0; i< N; i++) {
  a = a + rand(); 
}
for (j = 0; j< M; j++) {
  b = b + rand(); 
}
												</code>
											</pre>
										</p>
									</div>
								</div>
							</div>

					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q4-c1">
								<div class="art-body">
									<p>(A) O(N * M) time, O(1) space</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q4-c2">
								<div class="art-body">
									<p>(B) O(N + M) time, O(N + M) space</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q4-c3">
								<div class="art-body">
									<p>(C) O(N + M) time, O(1) space</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q4-c4">
								<div class="art-body">
									<p>(D) O(N * M) time, O(N + M) space</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>The first loop runs for O(n) time, second loop runs for O(m). Constant extra space is used for 2 variables a and b, hence O(1) space.
								</p>
							</div>
						</div>
					</div>
				</div>

				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question5">
							<div class="art-body">
								<p>Q5. For a given graph G having v vertices and e edges which is connected and has no cycles, which of the following statements is true?</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q5-c1">
								<div class="art-body">
									<p>(A) v=e</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q5-c2">
								<div class="art-body">
									<p>(B) v = e+1</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q5-c3">
								<div class="art-body">
									<p>(C) v + 1 = e</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q5-c4">
								<div class="art-body">
									<p>(D) v = e-1</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>For any connected graph with no cycles the equation holds true. 
								</p>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>

		<div class="lu" title="Dijkstra’s Algorithm">
			<div class="longt">
				<h2 class="hlongt">Dijkstra’s Algorithm</h2>
			</div>

			<div class="preamble">
				<div class="art txt" title="Estimation">
					<div class="longt">
						<h2 class="hlongt">Estimated Time</h2>
					</div>
					<div class="art-body">
						<p>30 minutes</p>
					</div>
				</div>
				<div class="art req" title="Dijkstra’s Algorithm overview">
					<div class="longt">
						<h2 class="hlongt">Dijkstra’s Algorithm overview</h2>
					</div>
					<div class="description">
						<p>Video giving a brief overview of Dijkstra’s Algorithm</p>
					</div>
				</div>
				<div class="art txt" title="Objectives">
					<div class="longt">
						<h2 class="hlongt">Learning Objectives of this Module:</h2>
					</div>
					<div class="art-body">
						<p>In this module, we will learn about:</p>
						<ol>
							<li>Need for Single Source Shortest Path algorithms</li>
							<li>Intuition for Dijkstra’s algorithm</li>
							<li>How to apply Dijkstra’s algorithm</li>
							<li>Practice the Algorithm</li>
							<li>Conceptual understanding with a short quiz</li>
						</ol>
					</div>
				</div>
			</div>
			<div class="task" title="Basic Concept">
				<div class="longt">
					<h2 class="hlongt">Understanding the Dijkstra's Algorithm</h2>
				</div>
				<div class="art txt" title="Basic Intuition">
					<div class="longt">
						<h2 class="hlongt">The Problem</h2>
					</div>
					<div class="art-body">
						<p>
							<li>In many applications one wants to obtain the shortest path from a to b.</li> 
							<li>Depending on the context, the length of the path does not necessarily have to be the length in meter: </li>
							<li>One can as well look at the cost of a path – both if we have to pay for using
							it – or if we receive some. In general we speak of cost.Therefore one assigns cost to each part of the path – also called "edge". </li> 
							<li>Dijkstra's Algorithm computes shortest – or cheapest paths, if all cost are positive numbers.</li>
							<li>However, if one allows negative numbers, the algorithm will fail.</li>
						</p>

					</div>
				</div>
				<div class="art txt" title="Other SSSPs">
					<div class="longt">
						<h2 class="hlongt">Other single source shortest path algorithms</h2>
					</div>
					<div class="art-body">
						<p>
							Let's take note of other single source shortest path algorithms and their Applications:
							<ul>
								<li>
									<b>Bellman–Ford algorithm:</b> The Bellman–Ford algorithm is an algorithm that computes shortest paths from a single source vertex to all of the other vertices in a weighted digraph. It is slower than Dijkstra's algorithm
									for the same problem, but more versatile, as it is capable of handling graphs in which some of the edge weights are negative numbers.<br> Like Dijkstra's algorithm, Bellman–Ford proceeds by relaxation, in which approximations
									to the correct distance are replaced by better ones until they eventually reach the solution.
								</li>
								<li>
									<b>BFS algorithm:</b>If the graph is unweighted, we can solve this problem in O(V + E) time. The idea is to use a modified version of Breadth-first search in which we keep storing the predecessor of a given vertex while
									doing the breadth first search. This algorithm will work even when negative weight cycles are present in the graph.
								</li>
							</ul>
						</p>
					</div>
				</div>
				<div class="art txt" title="Dijkstra’s Algorithm">
					<div class="longt">
						<h2 class="hlongt">Why and where Dijkstra’s Algorithm is used?</h2>
					</div>
					<div class="art-body">
						<p>
							Dijkstra’s algorithm is used when the graph has positive weights only. It is faster than the above other single source shortest path algorithms.
						</p>
					</div>
				</div>
			</div>
			<div class="task" title="Dijkstra's Algorithm">
				<div class="longt">
					<h2 class="hlongt">Demonstration for Dijkstra's Algorithm</h2>
				</div>
				<div class="art req" title="Dijkstra's Algorithm">
					<div class="longt">
						<h2 class="hlongt">Dijkstra's Algorithm</h2>
					</div>
					<div class="description">
						<p>Video for Dijkstra's Algorithm</p>
					</div>
				</div>
				<div class="art txt" title="Algorithm">
					<div class="longt">
						<h2 class="hlongt">Dijkstra's Algorithm</h2>
					</div>
					<div class="art-body">
						<p>
							<ol>
								<li>Set the distance to the source to 0 and the distance to the remaining vertices to infinity.</li>
								<li>Set the current vertex to the source.</li>
								<li>Flag the current vertex as visited.</li>
								<li>For all vertices adjacent to the current vertex, set the distance from the source to the adjacent vertex equal to the minimum of its present distance and the sum of the weight of the edge from the current vertex to the
								adjacent vertex and the distance from the source to the current vertex.</li>
								<li>From the set of unvisited vertices, arbitrarily set one as the new current vertex, provided that there exists an edge to it such that it is the minimum of all edges from a vertex in the set of visited vertices to a vertex
									in the set of unvisited vertices. To reiterate: The new current vertex must be unvisited and have a minimum weight edges from a visited vertex to it. This can be done trivially by looping through all visited vertices
								and all adjacent unvisited vertices to those visited vertices, keeping the vertex with the minimum weight edge connecting it.</li>
								<li>Repeat steps 3-5 until all vertices are flagged as visited.</li>
							</ol>
						</p>
					</div>
				</div>
				<div class="art txt" title="Pseudocode">
					<div class="longt">
						<h2 class="hlongt">Pseudocode</h2>
					</div>
					<div class="art-body">
						<p>
							<pre>
								<b>function</b> Dijkstra(<i>Graph</i>, <i>source</i>):
								dist[<i>source</i>] ← 0                           <i>// Initialization</i>
								
								create vertex set Q
								
								<b>for each</b> vertex <i>v</i> in <i>Graph</i>:           
								<b>if</b> <i>v</i> ≠ <i>source</i>
								dist[<i>v</i>] ← INFINITY                 <i>// Unknown distance from source to v</i>
								prev[<i>v</i>] ← UNDEFINED                    <i>// Predecessor of v</i>
								
								<i>Q</i>.add_with_priority(<i>v</i>, dist[<i>v</i>])
								
								
								<b>while</b> <i>Q</i> is not empty:                      <i>// The main loop</i>
								<i>u</i> ← <i>Q</i>.extract_min()                    <i>// Remove and return best vertex</i>
								<b>for each</b> neighbor <i>v</i> of <i>u</i>:       <i>// only v that are still in Q</i>
								<i>alt</i> ← dist[<i>u</i>] + length(<i>u</i>, <i>v</i>) 
								<b>if</b> <i>alt</i> &lt; dist[<i>v</i>]
								dist[<i>v</i>] ← <i>alt</i>
								prev[<i>v</i>] ← <i>u</i>
								<i>Q</i>.decrease_priority(<i>v</i>, <i>alt</i>)
								
								<b>return</b> dist, prev
							</pre>
						</p>
					</div>
				</div>
			</div>
			<div class="task" title="Dijkstra’s Algorithm Demo">
				<div class="longt">
					<h2 class="hlongt">Demonstration for Dijkstra’s Algorithm</h2>
				</div>
				<div class="art req" title="Dijkstra’s Demo">
					<div class="longt">
						<h2 class="hlongt">Interactive module for Demonstrating Dijkstra Algorithm</h2>
					</div>
					<div class="description">
						<p>
							A Demonstration module which helps the learner to visualize the Dijkstra’s Algorithm on a graph.
							<br>Learner can go step by step from the start node towards the end node. making a choice at every node along the way.
							<br>Also gives them an insight for the calculation of time and space complexity of the traversal.
						</p>
					</div>
				</div>
			</div>
			<div class="task" title="Dijkstra’s Algorithm Practice">
				<div class="longt">
					<h2 class="hlongt">Practice for Dijkstra’s Algorithm</h2>
				</div>
				<div class="art req" title="Practice : Dijkstra’s Algorithm">
					<div class="longt">
						<h2 class="hlongt">Interactive module for Practicing Dijkstra’s Algorithm</h2>
					</div>
					<div class="description">
						<p>
							A practice module
						</p>
					</div>
				</div>
			</div>
			<div class="task" title="Dijkstra’s Algorithm Exercise">
				<div class="longt">
					<h2 class="hlongt">Exercise for Dijkstra’s Algorithm</h2>
				</div>
				<div class="art req" title="Exercise : Dijkstra’s Algorithm">
					<div class="longt">
						<h2 class="hlongt">Exercise for Dijkstra’s Algorithm</h2>
					</div>
					<div class="description">
						<p>
							An Exercise module.
						</p>
					</div>
				</div>
			</div>
			<div class="quiz" title="Dijkstra's Algorithm Quiz">
				<div class="longt">
					<h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
				</div>

				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question1">
							<div class="art-body">
								<p>Q1. Dijkstra’s algorithm cannot be applied on ____.</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q1-c1">
								<div class="art-body">
									<p>(A) Directed and weighted graphs</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q1-c2">
								<div class="art-body">
									<p>(B) Container of objects of similar types</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q1-c3">
								<div class="art-body">
									<p>(C) Container of objects of mixed types</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q1-c4">
								<div class="art-body">
									<p>(D) All of the mentioned</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>An array is a data structure, which can store a fixed-size collection of elements of the same data type.
								</p>
							</div>
						</div>
					</div>
				</div>

				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question2">
							<div class="art-body">
								<p>Q2. Dijkstra’s Algorithm is the prime example for ________.</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q2-c1">
								<div class="art-body">
									<p>(A) Greedy algorithm</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q2-c2">
								<div class="art-body">
									<p>(B) Branch and bound</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q2-c3">
								<div class="art-body">
									<p>(C) Back tracking</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q2-c4">
								<div class="art-body">
									<p>(D) Dynamic programming</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>Dijkstra’s Algorithm is the prime example for greedy algorithms because greedy algorithms generally solve a problem in stages by doing what appears to be the best thing at each stage.
								</p>
							</div>
						</div>
					</div>
				</div>
				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question3">
							<div class="art-body">
								<p>Q3. Given a directed graph where weight of every edge is same, we can efficiently find shortest path from a given source to destination using _______.
								</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q3-c1">
								<div class="art-body">
									<p>(A) Dijkstra’s Shortest Path Algorithm</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q3-c2">
								<div class="art-body">
									<p>(B) Neither Breadth First Traversal nor Dijkstra’s algorithm can be used</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q3-c3">
								<div class="art-body">
									<p>(C) Depth First Search</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q3-c4">
								<div class="art-body">
									<p>(D) Breadth First Traversal</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>With Breadth First Search, we first find explore vertices at one edge distance, then all vertices at 2 edge distance, and so on.
								</p>
							</div>
						</div>
					</div>
				</div>

				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question4">
							<div class="art-body">
								<p>Q4. In an unweighted, undirected connected graph, the shortest path from a node S to every other node is computed most efficiently, in terms of time complexity by ________. 
								</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q4-c1">
								<div class="art-body">
									<p>(A) Dijkstra’s algorithm starting from S.</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q4-c2">
								<div class="art-body">
									<p>(B) Warshall’s algorithm</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q4-c3">
								<div class="art-body">
									<p>(C) Performing a DFS starting from S.</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q4-c4">
								<div class="art-body">
									<p>(D) Performing a BFS starting from S.</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>Time Comlexity of the Dijkstra’s algorithm is O(|V|^2 + E)<br>  
									Time Comlexity of the Warshall’s algorithm is O(|V|^3)<br>
									DFS cannot be used for finding shortest paths<br>
									BFS can be used for unweighted graphs. Time Complexity for BFS is O(|E| + |V|)
								</p>
							</div>
						</div>
					</div>
				</div>

				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question5">
							<div class="art-body">
								<p>Q5. Which of the following algorithm can be used to efficiently calculate single source shortest paths in a Directed Acyclic Graph? 
								</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q5-c1">
								<div class="art-body">
									<p>(A) Dijkstra</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q5-c2">
								<div class="art-body">
									<p>(B) Bellman-Ford</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q5-c3">
								<div class="art-body">
									<p>(C) Topological Sort</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q5-c4">
								<div class="art-body">
									<p>(D) Strongly Connected Component</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>Time Comlexity of the Dijkstra’s algorithm is O(|V|^2 + E)<br>  
									Time Comlexity of the Warshall’s algorithm is O(|V|^3)<br>
									DFS cannot be used for finding shortest paths<br>
									BFS can be used for unweighted graphs. Time Complexity for BFS is O(|E| + |V|)
								</p>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="lu" title="Analysis">
			<div class="longt">
				<h2 class="hlongt">Analysis</h2>
			</div>
			<div class="preamble">
				<div class="art txt" title="Estimation">
					<div class="longt">
						<h2 class="hlongt">Estimated Time</h2>
					</div>
					<div class="art-body">
						<p>10 minutes</p>
					</div>
				</div>
				<div class="art req" title="Analysis of Dijkstra’s Algorithm">
					<div class="longt">
						<h2 class="hlongt">Video for analyzing Dijkstra’s Algorithm</h2>
					</div>
					<div class="description">
						<p>A video which helps the learner to analyze the algorithm
							<br>also calculation of time and space complexity of the operation.
						</p>
					</div>
				</div>
				<div class="art txt" title="Objectives">
					<div class="longt">
						<h2 class="hlongt">Learning Objectives of this Module:</h2>
					</div>
					<div class="art-body">
						<p>
							In this module, we will be learning about:
							<ul>
								<li>Time and Space complexity: We will learn about the running time of one iteration, and then extend it to N iterations to complete the sorting process.</li>
								<li>Comparison with other algorithms: We will compare Bubble sort with other sorting algorithms and see in which situations Bubble sort is the optimal/not optimal approach to take.</li>
								<br>
							</ul>
						</p>
					</div>
				</div>
			</div>
			<div class="task" title="Time and Space Complexity">
				<div class="longt">
					<h2 class="hlongt">Time and Space Complexity of Dijkstra’s algorithm</h2>
				</div>
				<div class="art txt" title="Time Complexity">
					<div class="longt">
						<h2 class="hlongt">Running Time of Dijkstra’s algorithm</h2>
					</div>
					<div class="art-body">
						<p>The time complexity of the given code/algorithm looks O(V^2) as there are two nested while loops. If we take a closer look, we can observe that the statements in inner loop are executed O(V+E) times (similar to BFS). The inner
							loop has decreaseKey() operation which takes O(LogV) time. So overall time complexity is O(E+V)*O(LogV) which is O((E+V)*LogV) = O(ELogV) Note that the above code uses Binary Heap for Priority Queue implementation. Time complexity
						can be reduced to O(E + VLogV) using Fibonacci Heap. The reason is, Fibonacci Heap takes O(1) time for decrease-key operation while Binary Heap takes O(Logn) time.</p>
					</div>
				</div>
				<div class="art txt" title="Best and Worst Cases">
					<div class="longt">
						<h2 class="hlongt">Best and Worst Cases for Dijkstra’s Algorithm</h2>
					</div>
					<div class="art-body">
						<p>
							<ul>
							<li>
							The worst case (where <b>log</b> denotes the binary logarithm <b>log 2 </b>) for connected graphs this time bound can be simplified to <b>Θ (|E|log⁡ |V|) </b>. The Fibonacci heap improves this to <b> O(|E| + |V| * log⁡ |V|)</b>.
							</li>
							<li>
							When using binary heaps, the average case time complexity is lower than the worst-case: assuming edge costs are drawn independently from a common probability distribution, the expected number of decrease-key operations is bounded by 
							<b>O(|V| * log(|E| / |V|))</b>, giving a total running time of 
							<b>O(|E| + |V| * log ⁡|E| / |V| * log⁡ |V|)</b>. </li>
							</ul>
						</p>
					</div>
				</div>
				<div class="art req" title="Dijkstra’s Algorithm Complexity">
					<div class="longt">
						<h2 class="hlongt">Time complexity of Dijkstra’s Algorithm</h2>
					</div>
					<div class="description">
						<p>
							<br>Learner can input a random number and then go step by step from the start node towards the correct location for all the nodes.
							<br>Also gives them an insight for the calculation of time and space complexity of the operation.
						</p>
					</div>
				</div>
				<div class="art txt" title="Space Complexity">
					<div class="longt">
						<h2 class="hlongt">Space complexity of Dijkstra’s algorithm</h2>
					</div>
					<div class="art-body">
						<p>Space complexity of Dijkstra’s algorithm is O(V<sup>2</sup>) where V denotes the number of vertices (or nodes) in the graph.</p>
					</div>
				</div>
			</div>
			<div class="task" title="Comparison with other algorithms">
				<div class="longt">
					<h2 class="hlongt">Comparison with other algorithms</h2>
				</div>
				<div class="art req" title="Comparison Graphs">
					<div class="longt">
						<h2 class="hlongt">Graph: Time Complexities of Shortest path Algorithms</h2>
					</div>
					<div class="description">
						<p>A video which helps the learner to visualize the operation using the below interavtive module.
							<br>also calculation of time and space complexity of the operation.
						</p>
					</div>
				</div>
				<div class="art txt" title="Comparison Table">
					<div class="longt">
						<h2 class="hlongt">Comparison with other algorithms</h2>
					</div>
					<div class="art-body">
						<p>
							There are mainly three other single source shortest path algorithms:
							<ul>
								<li>
									Bellman Ford: n <sup>3</sup>
								</li>
								<li>
									Floyd Warshal: n*e
								</li>
							</ul>
						</p>
					</div>
				</div>
			</div>
			<div class="quiz" title="Analysis Quiz">
				<div class="longt">
					<h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
				</div>

				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question1">
							<div class="art-body">
								<p>Q1. Which of the following statement(s)is / are correct regarding Bellman-Ford shortest path algorithm?
									<br>
									P: Always finds a negative weighted cycle, if one exist s.<br>
									Q: Finds whether any negative weighted cycle is reachable 
								from the source. </p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q1-c1">
								<div class="art-body">
									<p>(A) P Only</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q1-c2">
								<div class="art-body">
									<p>(B) Q Only</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q1-c3">
								<div class="art-body">
									<p>(C) Both P and Q</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q1-c4">
								<div class="art-body">
									<p>(D) All of the mentioned</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>An array is a data structure, which can store a fixed-size collection of elements of the same data type.
								</p>
							</div>
						</div>
					</div>
				</div>

				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question2">
							<div class="art-body">
								<p>Q2. What is the time complexity of insertion at any point on an array?</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q2-c1">
								<div class="art-body">
									<p>(A) O(N)</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q2-c2">
								<div class="art-body">
									<p>(B) O(N^2)</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q2-c3">
								<div class="art-body">
									<p>(C) O(NLogN)</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q2-c4">
								<div class="art-body">
									<p>(D) None of these</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>Taking a general example,inserting into the middle of an array, you have to shift all the elements after that element, so the complexity for insertion in that case is O(n). Worst case would be when you have to insert at
									the starting of the array,you will need to move n elements
								</p>
							</div>
						</div>
					</div>
				</div>
				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question3">
							<div class="art-body">
								<p>Q3. What does it mean when we say that an algorithm X is asymptotically more efficient than Y?</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q3-c1">
								<div class="art-body">
									<p>(A) X will always be a better choice for small inputs</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q3-c2">
								<div class="art-body">
									<p>(B) X will always be a better choice for large inputs</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q3-c3">
								<div class="art-body">
									<p>(C) Y will always be a better choice for small inputs</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q3-c4">
								<div class="art-body">
									<p>(D) X will always be a better choice for all inputs</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>Performance could be similar for small inputs, but definitely better for larger inputs
								</p>
							</div>
						</div>
					</div>
				</div>

				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question4">
							<div class="art-body">
								<p>Q4. In an unweighted, undirected connected graph, the shortest path from a node S to every other node is computed most efficiently, in terms of time complexity by______.
								</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q4-c1">
								<div class="art-body">
									<p>(A) Dijkstra’s algorithm starting from S.</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q4-c2">
								<div class="art-body">
									<p>(B) Warshall’s algorithm</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q4-c3">
								<div class="art-body">
									<p>(C) O(N + M) time, O(1) space</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q4-c4">
								<div class="art-body">
									<p>(D) O(N * M) time, O(N + M) space</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>The first loop runs for O(n) time, second loop runs for O(m). Constant extra space is used for 2 variables a and b, hence O(1) space.
								</p>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="lu" title="Post Test">
			<div class="longt">
				<h2 class="hlongt">Post Test of the Experiment</h2>
			</div>
			<div class="preamble">
				<div class="art txt" title="Estimation">
					<div class="longt">
						<h2 class="hlongt">Estimated Time</h2>
					</div>
					<div class="art-body">
						<p>10 minutes</p>
					</div>
				</div>
				<div class="art txt" title="Instructions">
					<div class="longt">
						<h2 class="hlongt">Instructions for Quiz</h2>
					</div>
					<div class="art-body">
						<p>Post Test includes questions on entire experiment concepts. Read the questions in the quiz section and select the correct option from the ones provided. Please note that some questions may have more than one correct response.
						</p>
					</div>
				</div>
			</div>

			<div class="quiz" title="Post-test Quiz">
				<div class="longt">
					<h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
				</div>

				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question1">
							<div class="art-body">
								<p>Q1. Let G be a directed graph whose vertex set is the set of numbers from 1 to 100. There is an edge from a vertex i to a vertex j iff either j = i + 1 or j = 3i. The minimum number of edges in a path in G from vertex 1 to vertex 100 is _____.</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q1-c1">
								<div class="art-body">
									<p>(A) 4</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q1-c2">
								<div class="art-body">
									<p>(B) 7</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q1-c3">
								<div class="art-body">
									<p>(C) 23</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q1-c4">
								<div class="art-body">
									<p>(D) 99</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>The task is to find minimum number of edges in a path in G from vertex 1 to vertex 100 such that we can move to either i+1 or 3i from a vertex i. 
								</p>
							</div>
						</div>
					</div>
				</div>

				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question2">
							<div class="art-body">
								<p>Q2. Let G = (V, E) be a simple undirected graph, and s be a particular vertex in it called the source. For x ∈ V, let d(x) denote the shortest distance in G from s to x. A breadth first search (BFS) is performed starting at s. Let T be the resultant BFS tree. If (u, v) is an edge of G that is not in T, then which one of the following CANNOT be the value of d(u) – d(v)?</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q2-c1">
								<div class="art-body">
									<p>(A) -1</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q2-c2">
								<div class="art-body">
									<p>(B) 0</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q2-c3">
								<div class="art-body">
									<p>(C) 1</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q2-c4">
								<div class="art-body">
									<p>(D) 2</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>Note that the given graph is undirected, so an edge (u, v) also means (v, u) is also an edge.
									Since a shorter path can always be obtained by using edge (u, v) or (v, u), the difference between d(u) and d(v) can not be more than 1.
								</p>
							</div>
						</div>
					</div>
				</div>
				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question3">
							<div class="art-body">
								<p>Q3. Consider a weighted undirected graph with positive edge weights and let uv be an edge in the graph. It is known that the shortest path from the source vertex s to u has weight 53 and the shortest path from s to v has weight 65. Which one of the following statements is always true?</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q3-c1">
								<div class="art-body">
									<p>(A) weight (u, v) &lt; 12</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q3-c2">
								<div class="art-body">
									<p>(B) weight (u, v) &LessSlantEqual; 12</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q3-c3">
								<div class="art-body">
									<p>(C) weight (u, v) &gt; 12</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q3-c4">
								<div class="art-body">
									<p>(D) weight (u, v) &GreaterSlantEqual; 12</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>The minimum weight happens when (S,U) + (U,V) = (S,V) Else (S,U) + (U,V) >= (S,V) Given (S,U) = 53, (S,V) = 65 53 + (U,V) >= 63 (U,V) >= 12.
								</p>
							</div>
						</div>
					</div>
				</div>

				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question4">
							<div class="art-body">
								<p>Q4. What is the time complexity of Dijikstra’s algorithm?
								</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q4-c1">
								<div class="art-body">
									<p>(A) O(N)</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q4-c2">
								<div class="art-body">
									<p>(B) O(N<sup>3</sup>)</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q4-c3">
								<div class="art-body">
									<p>(C) O(N<sup>2</sup>)</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q4-c4">
								<div class="art-body">
									<p>(D) O(logN)</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>Time complexity of Dijkstra’s algorithm is O(N2) because of the use of doubly nested for loops. It depends on how the Adjacency table is manipulated.
								</p>
							</div>
						</div>
					</div>
				</div>

				<div class="mcq">
					<div class="preamble">
						<div class="art txt" title="question5">
							<div class="art-body">
								<p>Q5. Given a directed graph where weight of every edge is same, we can efficiently find shortest path from a given source to destination using _______.
								</p>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="true">
						<div class="preamble">
							<div class="art txt" title="q5-c1">
								<div class="art-body">
									<p>(A) Breadth First Traversal</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q5-c2">
								<div class="art-body">
									<p>(B) Dijkstra's Shortest Path Algorithm</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q5-c3">
								<div class="art-body">
									<p>(C) Neither Breadth First Traversal nor Dijkstra's algorithm can be used</p>
								</div>
							</div>
						</div>
					</div>
					<div class="choice" data-correct="false">
						<div class="preamble">
							<div class="art txt" title="q5-c4">
								<div class="art-body">
									<p>(D) Depth First Search</p>
								</div>
							</div>
						</div>
					</div>
					<div class="explanation">
						<div class="art txt" title="Explanation">
							<div class="art-body">
								<p>With BFS, we first find explore vertices at one edge distance, then all vertices at 2 edge distance, and so on.
								</p>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="lu" title="Further Readings/References">
			<div class="longt">
				<h2 class="hlongt">Further Readings of the Experiment</h2>
			</div>
			<div class="preamble">
				<div class="art txt" title="Explore">
					<div class="longt">
						<h2 class="hlongt">Explore More About Dijkstra’s algorithm</h2>
					</div>
					<div class="art-body">
						<p>You can explore more about Dijkstra’s shortest path algorithm Experiment through following resources:
						</p><br>
						<p>
							<h4>Animations</h4>
							<ul>
								<li><a href="http://weierstrass.is.tokushima-u.ac.jp/ikeda/suuri/dijkstra/DijkstraApp.shtml?demo1">a (6,10) graph </a></li>
								<li><a href="http://weierstrass.is.tokushima-u.ac.jp/ikeda/suuri/dijkstra/DijkstraApp.shtml?demo6">a (8,12) graph </a></li>
								<li><a href="http://weierstrass.is.tokushima-u.ac.jp/ikeda/suuri/dijkstra/DijkstraApp.shtml?demo7"> a (6,12) graph </a></li>
							</ul>
						</p>
						<p>
							<h4>Other resources</h4>
							<ul>
								<li><a href="weierstrass.is.tokushima-u.ac.jp/ikeda/suuri/main/index.shtml">Mathematical Programming</a> by <a href="http://www-b2.is.tokushima-u.ac.jp/~ikeda">Kenji Ikeda</a></li>
								<li><a href="https://www.geeksforgeeks.org/">Geeks for Geeks</a></li>
								<li><a href="https://www.hackerrank.com/topics/">HackerRank</a></li>
								<li><a href="https://en.wikipedia.org/wiki/">Wikipedia</a></li>
							</ul>
						</p>
						<p>
							<h4>Credits:</h4>
							<a href="http://weierstrass.is.tokushima-u.ac.jp/ikeda/suuri/dijkstra/Dijkstra.shtml">Kenji Ikeda 2015</a> 
							Thanks for giving us permission to use your js codes according to General Public Licence (GPL).
						</p>
					</div>
				</div>
			</div>
		</div>
	</div>
	<script type="text/javascript" src="./js/loader.js"></script>
</body>
</html>
